use strict;
use warnings;
use Encode;
use Encode::Guess;
use IO::Socket;

# extended URL Parameter:
#
# tmp=<Encoded Page name>
#   This is the instead of url-parameter 'p'. It is encoded with unpack 
#   function because some blog-system convert url-parameter from utf-8 
#   to euc-jp.
#
# tb=<Trackback-URL>
#   same that tmp=<Trackback-URL>;a=tb 


if( $::form{tb} && $::form{tb} =~ /^([0-9a-f]{2})+$/ ){
    $::form{p} = pack('h*',$&);
    $::form{a} = 'tb';
}

if( $::form{tmp} && $::form{tmp} =~ /^([0-9a-f]{2})+$/ ){
    $::form{p} = pack('h*',$&);
    unless( $::form{a} ){
        unshift(@::http_header,'Location: '.$::me.'?p='.&::percent($::form{p}));
        unshift(@::http_header,'Status: 303 See Other');
    }
}

my $wifkyEncode = $::charset eq 'EUC-JP'
                ? find_encoding('euc-jp')
                : find_encoding('utf8'  );

$::action_plugin{tb} = sub{

    if( $::config{debugmode} && open(my $debug,'>','./debug.txt') ){
        while( my ($key,$val)=each %::form ){
            printf $debug "%s=%s\n",$key,$val || '(ZERO)';
        }
        close($debug);
    }

    eval{
        my $url  =$::form{url} or die("Parameter URL not found.");
        my $page =$::form{p}   or die("Parameter P   not found.");
        my $fname=&::title2fname($page,"trackback.txt");
        utime( time() , time() , &::title2fname($page) ) > 0
            or die("unable to comment to unexistant page.");


        open(my $fp,'>>',$fname) or die("Can not open $fname for append");
            my @tm=localtime();
            my $text = join("\t",map( &::yen($_) 
                        , sprintf("%04d/%02d/%02d %02d:%02d:%02d"
                            , 1900+$tm[5],1+$tm[4],@tm[3,2,1,0])
                        , $url 
                        , $::form{title}     || $url 
                        , $::form{blog_name} || ""
                        , $::form{excerpt}   || "" ) );
            if( $::form{charset} =~ /s(hift)?[-_]?jis/i ){
                $text = decode('shiftjis',$text);
            }elsif( $::form{charset} =~ /euc([-_]?jp)?/i ){
                $text = decode('euc-jp',$text);
            }elsif( $::form{charset} =~ /utf[-_]?8/i ){
                $text = decode('utf8',$text);
            }else{
                my $enc = guess_encoding($text,qw/utf-8 euc-jp shiftjis 7bit-jis/);
                if( ref($enc) ){
                    $text = $enc->decode($text);
                }else{
                    $text = decode( (split(/\s+/,$enc))[0] , $text );
                }
            }
            $text = substr($text,0,256) if length($text)>256;
            print{$fp} $wifkyEncode->encode($text),"\r\n";
        close($fp);
    };
    if( $@ ){
        my $message=&::enc($@);
        print <<HERE;
Content-Type: text/xml

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>1</error>
<message>${message}</message>
</response>
HERE
    }else{
        print <<HERE;
Content-Type: text/xml

<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>0</error>
</response>
HERE
    }
    exit(0);
};

$::inline_plugin{trackback} = sub {
    my $list=&::read_object($::form{p},'trackback.txt');
    if( $list ){
        $list = 'Trackback List:<dl>' . join("",
            map{
                my ($time,$url,$title,$blog_name,$excerpt)=split(/\t/,$_);
                sprintf('<dt><a href="%s">%s %s</a>(%s)</dt><dd>%s</dd>'
                        , &::enc($url) , &::enc($title) , &::enc($blog_name)
                        , &::enc($time) , &::enc(&::deyen($excerpt)) );
            } split(/\r?\n/,$list)
        ) . '</dl>';
    }
    local $::me='http://'.$ENV{'HTTP_HOST'}.$ENV{'SCRIPT_NAME'};
    my $url=&::myurl( { tb=>unpack('h*',$::form{p}) } );
    sprintf('%s<form>Trackback URL: <input type="text" value="%s" size="%d" readonly="readonly" style="font-family:monospace;font-size:small" onClick="this.select();" /></form>'
            , $list
            , $url
            , length($url) );
};

if( &::is_signed() ){
    $::form_list{'600_trackback'} = sub {
        if( $::form{a} eq 'edt'  &&  &::object_exists($::form{p}) ){
            &::puts('<h2>Send Trackback</h2>
                <div>URL: <input type="text" name="trackurl" value="" size="48" /></div>
                <div><textarea name="excerpt" cols="80" rows="5"></textarea></div><div>'
            );
            &::puts('<input type="submit" name="a" value="Send Trackback" /></div>');
        }
    };
}

$::action_plugin{'Send Trackback'} = sub {
    goto &::action_signin unless &::is_signed();

    my $trackurl=$::form{trackurl} or die("Trackback URL not found");

    if( $trackurl !~ m|^http://([^/]+)| ){
        die('Invalid URL');
    }
    my $host     = $1;
    my $path     = $';

    my $http = IO::Socket::INET->new("$host:80") or die("socket error.\n");
    binmode($http);

    my $blog_name=$wifkyEncode->decode( $::config{sitename} );
    my $page_name=$wifkyEncode->decode( $::form{p} );
    my $excerpt  =$wifkyEncode->decode( $::form{excerpt} );

    my $myurl=sprintf('http://%s%s?tmp=%s' 
                , $ENV{'HTTP_HOST'}
                , $ENV{'SCRIPT_NAME'}
                , unpack('h*',$::form{p}) );

    my $body=sprintf('url=%s&charset=utf-8&title=%s&excerpt=%s&blog_name=%s'
        , &::percent($myurl),
        , &::enc(&::percent( encode_utf8($page_name) ) )
        , &::enc(&::percent( encode_utf8($excerpt  ) ) )
        , &::enc(&::percent( encode_utf8($blog_name) ) )
    );

    print "Content-type: text/html; charset=utf-8\n\n";
    print "<html><head><title>Trackback Result</title></head><body>\n";
    print "<h1>Trackback Result</h1>\n";
    printf qq(<p>From: <a href="%s">%s</a><br>To: %s</p>\n) ,
               &::enc($myurl) , &::enc($myurl) , &::enc($trackurl);

    print '<h2>send data</h2>';

    &tee( $http,"POST $path HTTP/1.1\n");
    &tee( $http,"Host: $host\n");
    &tee( $http,"Content-Length: ".length($body)."\n");
    &tee( $http,"Content-Type: application/x-www-form-urlencoded; charset=utf-8\n" );
    &tee( $http,"Connection: close\n");
    &tee( $http,"\n");
    &tee( $http,$body );
    $http->flush();

    print '<h2>recieve data</h2>';

    while( <$http> ){
        print &::enc($_),'<br>';
    }
    print '</pre></body></html>'; 
    close($http);
    exit(0);
};

sub tee{
    my $http=shift;
    print $http @_;
    print &::enc($_),'<br>' for(@_);
}

1;
